/*
 * Created on 2005/03/28
 */
package net.asukaze.anxious;

import java.awt.BorderLayout;
import java.awt.FileDialog;
import java.awt.event.KeyEvent;
import java.io.FileNotFoundException;

import javax.swing.JFrame;

import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JLabel;
/**
 * @author asukaze
 */
public class MainForm extends JFrame {
	private Manager manager;
	private Problem problem;
	private boolean failed;
	
	private javax.swing.JPanel jContentPane = null;
	private javax.swing.JMenuBar jJMenuBar = null;
	private javax.swing.JMenu fileMenu = null;
	private javax.swing.JMenu optionMenu = null;
	private javax.swing.JMenu helpMenu = null;
	private javax.swing.JMenuItem exitMenuItem = null;
	private javax.swing.JMenuItem aboutMenuItem = null;
	private javax.swing.JMenuItem openMenuItem = null;
	private javax.swing.JMenuItem optionMenuItem = null;
	private JPanel jAnswerPanel = null;
	private JTextArea taQuestion = null;
	private JTextField txtAnswer = null;
	private JLabel lblLogo = null;
	private JButton btnOK = null;
	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJAnswerPanel() {
		if (jAnswerPanel == null) {
			lblLogo = new JLabel();
			jAnswerPanel = new JPanel();
			lblLogo.setText("AnxiousJ Alpha 2005.03.29");
			jAnswerPanel.setLayout(new BorderLayout());
			jAnswerPanel.add(getTxtAnswer(), BorderLayout.NORTH);
			jAnswerPanel.add(lblLogo, BorderLayout.WEST);
			jAnswerPanel.add(getBtnOK(), BorderLayout.EAST);
		}
		return jAnswerPanel;
	}
	/**
	 * This method initializes jTextArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */    
	private JTextArea getTaQuestion() {
		if (taQuestion == null) {
			taQuestion = new JTextArea();
			taQuestion.setEditable(false);
			taQuestion.setLineWrap(true);
		}
		return taQuestion;
	}
	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getTxtAnswer() {
		if (txtAnswer == null) {
			txtAnswer = new JTextField();
			txtAnswer.addKeyListener(new java.awt.event.KeyAdapter() {   
				public void keyPressed(java.awt.event.KeyEvent e) {    
					if(e.getKeyCode() == KeyEvent.VK_ENTER){
						checkAnswer();
					}
				} 
			});
		}
		return txtAnswer;
	}
	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getBtnOK() {
		if (btnOK == null) {
			btnOK = new JButton();
			btnOK.setText("OK");
			btnOK.setEnabled(false);
			btnOK.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					checkAnswer();
				}
			});
		}
		return btnOK;
	}
     public static void main(String[] args) {
		MainForm application = new MainForm();
		application.show();
	}

	/**
	 * This is the default constructor
	 */
	public MainForm() {
		super();
		initialize();
	}
	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setDefaultCloseOperation(javax.swing.JFrame.EXIT_ON_CLOSE);
		this.setJMenuBar(getJJMenuBar());
		this.setSize(300,200);
		this.setContentPane(getJContentPane());
		this.setTitle("AnxiousJ");
	}
	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if(jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(new java.awt.BorderLayout());
			jContentPane.add(getTaQuestion(), java.awt.BorderLayout.CENTER);
			jContentPane.add(getJAnswerPanel(), java.awt.BorderLayout.SOUTH);
		}
		return jContentPane;
	}
	/**
	 * This method initializes jJMenuBar	
	 * 	
	 * @return javax.swing.JMenuBar	
	 */    
	private javax.swing.JMenuBar getJJMenuBar() {
		if (jJMenuBar == null) {
			jJMenuBar = new javax.swing.JMenuBar();
			jJMenuBar.add(getFileMenu());
			jJMenuBar.add(getOptionMenu());
			jJMenuBar.add(getHelpMenu());
		}
		return jJMenuBar;
	}
	/**
	 * This method initializes jMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */    
	private javax.swing.JMenu getFileMenu() {
		if (fileMenu == null) {
			fileMenu = new javax.swing.JMenu();
			fileMenu.setText("File");
			fileMenu.add(getOpenMenuItem());
			fileMenu.add(getExitMenuItem());
		}
		return fileMenu;
	}
	/**
	 * This method initializes jMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */    
	private javax.swing.JMenu getOptionMenu() {
		if (optionMenu == null) {
			optionMenu = new javax.swing.JMenu();
			optionMenu.setText("Option");
			optionMenu.add(getOptionMenuItem());
		}
		return optionMenu;
	}
	/**
	 * This method initializes jMenu	
	 * 	
	 * @return javax.swing.JMenu	
	 */    
	private javax.swing.JMenu getHelpMenu() {
		if (helpMenu == null) {
			helpMenu = new javax.swing.JMenu();
			helpMenu.setText("Help");
			helpMenu.add(getAboutMenuItem());
		}
		return helpMenu;
	}
	/**
	 * This method initializes jMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private javax.swing.JMenuItem getExitMenuItem() {
		if (exitMenuItem == null) {
			exitMenuItem = new javax.swing.JMenuItem();
			exitMenuItem.setText("Exit");
			exitMenuItem.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					System.exit(0);
				}
			});
		}
		return exitMenuItem;
	}
	/**
	 * This method initializes jMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private javax.swing.JMenuItem getAboutMenuItem() {
		if (aboutMenuItem == null) {
			aboutMenuItem = new javax.swing.JMenuItem();
			aboutMenuItem.setText("About...");
		}
		return aboutMenuItem;
	}
	/**
	 * This method initializes jMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private javax.swing.JMenuItem getOpenMenuItem() {
		if (openMenuItem == null) {
			openMenuItem = new javax.swing.JMenuItem();
			openMenuItem.setText("Open...");
			openMenuItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_O, java.awt.Event.CTRL_MASK, true));
			openMenuItem.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					try{
						FileDialog openFileDialog = new FileDialog(MainForm.this, "t@CJ", FileDialog.LOAD);
						openFileDialog.show();
						if(openFileDialog.getFile() == null){ return; }
						manager = new Manager();
						manager.OpenFile(openFileDialog.getDirectory() + openFileDialog.getFile());
						nextProblem();
					}catch(FileNotFoundException exc){
					}
				}
			});
		}
		return openMenuItem;
	}
	/**
	 * This method initializes jMenuItem	
	 * 	
	 * @return javax.swing.JMenuItem	
	 */    
	private javax.swing.JMenuItem getOptionMenuItem() {
		if (optionMenuItem == null) {
			optionMenuItem = new javax.swing.JMenuItem();
			optionMenuItem.setText("Option...");
		}
		return optionMenuItem;
	}

	void nextProblem(){
		if(manager != null && manager.isStudying()){
			problem = manager.nextProblem();
			if(problem != null){
				taQuestion.setText(problem.getQuestion());
				failed = false;
				btnOK.setEnabled(true);
				txtAnswer.requestFocus();
			}else{
				taQuestion.setText("SII\r\nꂳ܂łB");
				btnOK.setEnabled(false);
			}
		}
	}

	void checkAnswer(){
		if(problem == null){ return; }
		String answer = txtAnswer.getText();
		String correct = problem.getCorrectAnswerFor(answer);
		if(answer.equals(correct)){
			manager.solved(problem, failed);
			nextProblem();
			txtAnswer.setText("");
		}else{
			failed = true;
			int len = Manager.hitLength(answer, correct);
			len++;
			String hint;
			if(len >= correct.length()){
				hint = correct;
			}else{
				hint = correct.substring(0,len) + "...";
			}
			taQuestion.setText(problem.getQuestion() + "\r\n(" + hint + ")");
		}
	}
}
